//
//  ListProductsPresenter.swift
//  shuup
//
//  Created by Yeison Vargas on 3/15/19.
//  Copyright (c) 2019 Rokk3rlabs. All rights reserved.
//
//  This file was generated by the Clean Swift Xcode Templates so
//  you can apply clean architecture to your iOS and Mac projects,
//  see http://clean-swift.com
//

import UIKit

protocol ListProductsPresentationLogic
{
  func presentProducts(response: ListProducts.FetchProducts.Response)
  func presentProductUpdate(response: ListProducts.UpdateStock.Response)
}

class ListProductsPresenter: ListProductsPresentationLogic
{

  weak var viewController: ListProductsDisplayLogic?
  
  // MARK: Do something
  
  func presentProducts(response: ListProducts.FetchProducts.Response)
  {

    var displayedProducts: [ListProducts.FetchProducts.ViewModel.DisplayedProduct] = []

    for product in response.products {
        let displayedProduct = ListProducts.FetchProducts.ViewModel.DisplayedProduct(
            id: Int(product.id) ?? -1, name: product.name, price: String(product.price), stock: String(product.stock)
        )
        displayedProducts.append(displayedProduct)
    }

    let viewModel = ListProducts.FetchProducts.ViewModel(displayedProducts: displayedProducts)
    viewController?.displayProducts(viewModel: viewModel)
  }

    func presentProductUpdate(response: ListProducts.UpdateStock.Response) {

        let displayUpdate = ListProducts.UpdateStock.ViewModel.DisplayedStockUpdated(id: response.product.id, stock: String(response.currentStock), removeFromSale: response.removeFromSale)

        let viewModel = ListProducts.UpdateStock.ViewModel(displayedStockUpdate: displayUpdate)
        viewController?.displayStockUpdate(viewModel: viewModel)
    }

}
